﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Net;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Xml;

namespace _69
{
    public partial class Form1 : Form
    {
        private int priblizeni = 0;
        private int x = 0;
        private int y = 0;
        private int mouseX = 384;
        private int mouseY = 384;
        private string[] mestaArray;
        private List<List<PictureBox>> dlazdice = new List<List<PictureBox>>();
        private List<KeyValuePair<Point, string>> mesta = new List<KeyValuePair<Point,string>>();

        public Form1()
        {
            InitializeComponent();
            MouseWheel += new MouseEventHandler(Form1_MouseWheel);
            priblizeniMinus.Enabled = false;
            for (int i = 0; i < 5; i++)
            {
                dlazdice.Add(new List<PictureBox>());
                for(int a = 0; a < 5; a++)
                {
                    dlazdice[i].Add(new PictureBox());
                    dlazdice[i][a].Size = new Size(256, 256);
                    dlazdice[i][a].Location = new Point((i - 1) * 256, (a - 1) * 256);
                    dlazdice[i][a].MouseDown += new MouseEventHandler(panel1_MouseDown);
                    dlazdice[i][a].MouseUp += new MouseEventHandler(panel1_MouseUp);
                    panel1.Controls.Add(dlazdice[i][a]);
                }
            }
            WebRequest webRequest = WebRequest.Create(adresaTextBox.Text + "/obce.xml");
            WebResponse webResponse = webRequest.GetResponse();
            StreamReader streamReader = new StreamReader(webResponse.GetResponseStream());
            string obce = streamReader.ReadToEnd();
            string[] obceRozdelene = Regex.Split(obce, "[\\\"]");
            for (int i = 1; i < obceRozdelene.Length; i += 6)
            {
                mesta.Add(new KeyValuePair<Point, string>(new Point(int.Parse(obceRozdelene[i + 2]), int.Parse(obceRozdelene[i + 4])), obceRozdelene[i]));
            }
            AutoCompleteStringCollection source = new AutoCompleteStringCollection();
            mestaArray = new string[mesta.Count];
            for (int i = 0; i < mesta.Count; i++)
            {
                mestaArray[i] = mesta[i].Value + " (X: " + mesta[i].Key.X.ToString() + ", Y: " + mesta[i].Key.Y.ToString() + ")";
            }
            source.AddRange(mestaArray);
            mestoTextBox.AutoCompleteCustomSource = source;
        }

        void Form1_MouseWheel(object sender, MouseEventArgs e)
        {
            if (e.Delta > 0)
            {
                if (priblizeni < 9)
                {
                    x *= 2;
                    y *= 2;
                    priblizeni++;
                    if (priblizeni == 9)
                        priblizeniPlus.Enabled = false;
                    priblizeniMinus.Enabled = true;
                    priblizeniLabel.Text = priblizeni.ToString();
                }
            }
            if (e.Delta < 0)
            {
                if (priblizeni > 0)
                {
                    x /= 2;
                    y /= 2;
                    priblizeni--;
                    if (priblizeni == 0)
                        priblizeniMinus.Enabled = false;
                    priblizeniPlus.Enabled = true;
                    priblizeniLabel.Text = priblizeni.ToString();
                }
            }
            vykreslitMapu();
        }

        private Image getDlazdice(string adresa)
        {
            try
            {
                WebRequest webRequest = WebRequest.Create(adresa);
                WebResponse webResponse = webRequest.GetResponse();
                Stream stream = webResponse.GetResponseStream();
                Image image = Image.FromStream(stream);
                return image;
            }
            catch
            {
                return null;
            }
        }

        private void priblizeniPlus_Click(object sender, EventArgs e)
        {
            priblizeni++;
            x *= 2;
            y *= 2;
            if (priblizeni == 9)
                priblizeniPlus.Enabled = false;
            priblizeniMinus.Enabled = true;
            priblizeniLabel.Text = priblizeni.ToString();
            vykreslitMapu();
        }

        private void priblizeniMinus_Click(object sender, EventArgs e)
        {
            priblizeni--;
            x /= 2;
            y /= 2;
            if (priblizeni == 0)
                priblizeniMinus.Enabled = false;
            priblizeniPlus.Enabled = true;
            priblizeniLabel.Text = priblizeni.ToString();
            vykreslitMapu();
        }

        private void zobrazitButton_Click(object sender, EventArgs e)
        {
            bool chyba = false;
            if(!int.TryParse(xTextBox.Text, out x))
            {
                MessageBox.Show("Souřadnice x musí být číslo!");
                chyba = true;
            }
            if (!int.TryParse(yTextBox.Text, out y))
            {
                MessageBox.Show("Souřadnice y musí být číslo!");
                chyba = true;
            }
            if(!chyba)
                vykreslitMapu();
        }

        private void vykreslitMapu()
        {
            xTextBox.Text = x.ToString();
            yTextBox.Text = y.ToString();
            for (int i = 0; i < 5; i++)
            {
                dlazdice.Add(new List<PictureBox>());
                for (int a = 0; a < 5; a++)
                {
                    Image image = getDlazdice(adresaTextBox.Text + "/" + priblizeni.ToString() + "/" + (x - 2 + i).ToString() + "/" + (y - 2 + a).ToString() + ".jpg");
                    dlazdice[i][a].Location = new Point((i - 1) * 256, (a - 1) * 256);
                    dlazdice[i][a].Image = image;
                }
            }
        }

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            mouseX = e.X;
            mouseY = e.Y;
        }

        private void panel1_MouseUp(object sender, MouseEventArgs e)
        {
            for (int i = 0; i < 5; i++)
            {
                for (int a = 0; a < 5; a++)
                {
                    dlazdice[i][a].Location = new Point(dlazdice[i][a].Location.X + mouseX - e.X, dlazdice[i][a].Location.Y + mouseY - e.Y);
                    /*if (dlazdice[i][a].Location.X < -256)
                    {
                        dlazdice[i][a].Location = new Point(dlazdice[i][a].Location.X + 1280, dlazdice[i][a].Location.Y);
                        x -= (int)(Math.Pow(2, priblizeni + 1));
                    }
                    if (dlazdice[i][a].Location.X > 1280)
                    {
                        dlazdice[i][a].Location = new Point(dlazdice[i][a].Location.X - 1280, dlazdice[i][a].Location.Y);
                        x += (int)(Math.Pow(2, priblizeni + 1));
                    }
                    if (dlazdice[i][a].Location.Y > 1280)
                    {
                        dlazdice[i][a].Location = new Point(dlazdice[i][a].Location.X, dlazdice[i][a].Location.Y - 1280);
                        y -= (int)(Math.Pow(2, priblizeni + 1));
                    }
                    if (dlazdice[i][a].Location.Y < -256)
                    {
                        dlazdice[i][a].Location = new Point(dlazdice[i][a].Location.X, dlazdice[i][a].Location.Y + 1280);
                        y += (int)(Math.Pow(2, priblizeni + 1));
                    }*/
                }
            }
        }

        private void zobrazitMesto_Click(object sender, EventArgs e)
        {
            if (!mestaArray.Contains(mestoTextBox.Text))
            {
                MessageBox.Show("Toto město není v seznamu!");
            }
            else
            {
                string[] lokace = Regex.Split(mestoTextBox.Text, @"[,:\)]");
                int x1 = int.Parse(lokace[1]);
                int y1 = int.Parse(lokace[3]);
                x = x1 / (int)(Math.Pow(4, 9 - priblizeni));
                y = y1 / (int)(Math.Pow(4, 9 - priblizeni));
                vykreslitMapu();
            }
        }
    }
}
